<template>
  <v-container>
    <v-row>
      <v-col cols="12" md="2"></v-col>
      <v-col cols="12" md="8">
        <v-card-text>
          <br>
          <h3 class="black--text text-left font-weight-medium">
            Registro
          </h3>
          <ValidationObserver ref="observer" v-slot="{ handleSubmit, invalid }">
            <v-form @submit.prevent="handleSubmit(register)" class="custom-error">
              <ValidationProvider
                  v-slot="{ errors }"
                  name="Nombre"
                  rules="required"
              >
                <v-text-field
                    label="Nombre"
                    autocomplete="off"
                    type="text"
                    name="text"
                    v-model="user.name"
                    :error-messages="errors"
                    append-icon="mdi-account"
                />
              </ValidationProvider>
              <ValidationProvider
                  v-slot="{ errors }"
                  name="Correo eléctronico"
                  rules="required|email"
              >
                <v-text-field
                    label="Correo eléctronico"
                    autocomplete="off"
                    type="email"
                    name="text"
                    v-model="user.email"
                    :error-messages="errors"
                    append-icon="mdi-account"
                />
              </ValidationProvider>
              <ValidationProvider
                  v-slot="{ errors }"
                  name="La contraseña"
                  rules="required"
              >
                <v-text-field
                    autocomplete="off"
                    label="Contraseña"
                    type="password"
                    name="password"
                    v-model="user.password"
                    :error-messages="errors"
                    append-icon="mdi-key"
                />
              </ValidationProvider>
              <v-card-actions>
                <v-btn block color="info" :loading="loading" :disabled="invalid" type="submit">Registrar</v-btn>
              </v-card-actions>
            </v-form>
          </ValidationObserver>
        </v-card-text>
      </v-col>
      <v-col cols="12" md="2"></v-col>
    </v-row>
  </v-container>
</template>

<script>
import { required, email } from "vee-validate/dist/rules";
import {
  extend,
  ValidationObserver,
  ValidationProvider,
  setInteractionMode,
} from "vee-validate";

setInteractionMode("eager");

extend("required", {
  ...required,
  message: "{_field_} no puede estar vacio.",
});

extend("email", {
  ...email,
  message: "{_field_} no es valído.",
});

export default {
  name: 'Home',
  components: {
    ValidationProvider,
    ValidationObserver
  },
  data:()=>({
    loading:false,
    user:{
      name:null,
      email:null,
      password:null
    }
  }),
  methods:{
    register(){
      this.loading=true
      this.$http.post('https://gohan-upjhfp6ytq-ue.a.run.app/api/register',this.user,{
        headers:{
          'Authorization': `Bearer ${this.$store.getters.token}`
        },
      }).then(res=>{
        console.log(res.data)
        if (res.data.success==true){
          this.$toast.success('Usuario registrado');
        }else{
          this.$toast.error('Algo salio mal, contactar a soporte');
        }

      }).finally(()=>{
        this.loading=false
        this.user={
          name:null,
          email:null,
          password:null
        }
        requestAnimationFrame(() => {
          this.$refs.observer.reset()
        })
      })
    }
  }
}
</script>
